/*   
ZZDrawingJ2D.java
 *    
 *    Copyright (c) 2000, Ted Nelson and Tuomas Lukka
 *
 *    You may use and distribute under the terms of either the GNU Lesser
 *    General Public License, either version 2 of the license or,
 *    at your choice, any later version. Alternatively, you may use and
 *    distribute under the terms of the XPL.
 *
 *    See the LICENSE.lgpl and LICENSE.xpl files for the specific terms of 
 *    the licenses.
 *
 *    This software is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the README
 *    file for more details.
 *
 */
/*
 * Written by Tuomas Lukka
 */
package org.gzigzag;
import java.awt.*;

/** An implementation of ZZDrawing for the Java2D API.
 */

public class ZZDrawingJ2D extends ZZDrawing {
public static final String rcsid = "$Id: ZZDrawingJ2D.java,v 1.4 2000/11/15 16:26:49 tjl Exp $";

    public void setAlpha(Graphics g0, float alpha) {
	Graphics2D g = (Graphics2D)g0;
	g.setComposite(AlphaComposite.getInstance(
			AlphaComposite.SRC_OVER, alpha));
    }

    RenderingHints qualityHints = new RenderingHints(null);
    {
	qualityHints.put(
	    RenderingHints.KEY_TEXT_ANTIALIASING,
	    RenderingHints.VALUE_TEXT_ANTIALIAS_ON);

//	qualityHints.put(RenderingHints.KEY_RENDERING,
//	    RenderingHints.VALUE_RENDER_QUALITY);

//	qualityHints.put(RenderingHints.KEY_FRACTIONALMETRICS,
//	    RenderingHints.VALUE_FRACTIONALMETRICS_ON);

    }

    public void setQuality(Graphics g0) {
	Graphics2D g = (Graphics2D)g0;
	g.setRenderingHints(qualityHints);
    }
}


