/*   
ContentHash.java
 *    
 *    Copyright (c) 2000, Ted Nelson and Tuomas Lukka
 *
 *    You may use and distribute under the terms of either the GNU Lesser
 *    General Public License, either version 2 of the license or,
 *    at your choice, any later version. Alternatively, you may use and
 *    distribute under the terms of the XPL.
 *
 *    See the LICENSE.lgpl and LICENSE.xpl files for the specific terms of 
 *    the licenses.
 *
 *    This software is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the README
 *    file for more details.
 *
 */
/*
 * Written by Tuomas Lukka
 */
package org.gzigzag;
import java.util.*;
import java.io.*;

/** DEPRECATED. A "hash" for contents of cells.
 * XXX SEPARATE CACHING TO A DIFFERENT CLASS
 */


public class ContentHash extends WritableHash implements ContentStore,
    Flushable {
public static final String rcsid = "$Id: ContentHash.java,v 1.4 2000/09/19 10:32:00 ajk Exp $";

    boolean docache;
    Hashtable cache;

    ContentHash(Writable writable) {
	this(writable, false);
    }
    ContentHash(Writable writable, boolean docache) {
	super(writable);
    }
    public void fillHdrRecord(Recs.HdrRecord h) {
	super.fillHdrRecord(h);
	h.id = 3423838; // Just a random thing.
    }

    public void put(String id, Object cont) {
	if(docache)
	    cache.put(id, cont);
	else
	    reallyPut(id, cont);
    }

    protected void reallyPut(String id, Object cont) {
	boolean span = false;
	String ct;
	if(cont instanceof Span) {
	    span = true;
	    ct = ((Span)cont).toString();
	} else {
	    ct = (String)cont;
	}
	Recs.ContentRecord r = new Recs.ContentRecord();
	r.hash = id.hashCode();
	r.cell = id;
	r.span = span;
	r.content = ct;
	putTreeRecord(r);
    }
	
    public Object get(String id) {

	Object o;
	if(docache && (o=cache.get(id)) != null) return o;

	int hash = id.hashCode();
	Recs.ContentRecord r = null; 
	do {
	    r = (Recs.ContentRecord)findRecord(r, hash);
	} while(r!=null && (r.hash != hash || !r.cell.equals(id)));
	if(r==null) return null;
	if(r.span) {
	    return Span.parse(r.content);
	} else {
	    return r.content;
	}
    }


    public boolean isCaching() { return docache; }
    public void flush() {
	// XXX sure do hope we're synchronized...
	for(Enumeration e = cache.keys(); e.hasMoreElements(); ) {
	    String id = (String) e.nextElement();
	    reallyPut(id, cache.get(id));
	}
	cache.clear();
    }
}
