/*   
DimHash.java
 *    
 *    Copyright (c) 2000, Ted Nelson and Tuomas Lukka
 *
 *    You may use and distribute under the terms of either the GNU Lesser
 *    General Public License, either version 2 of the license or,
 *    at your choice, any later version. Alternatively, you may use and
 *    distribute under the terms of the XPL.
 *
 *    See the LICENSE.lgpl and LICENSE.xpl files for the specific terms of 
 *    the licenses.
 *
 *    This software is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the README
 *    file for more details.
 *
 */
/*
 * Written by Tuomas Lukka
 */
package org.gzigzag;
import java.util.*;
import java.io.*;

/** DEPRECATED.
 * Use ZZCacheDimension and SimpleDimFile
 * A "hash" for a linked-list dimension.
 */

public class DimHash extends WritableHash implements DimStore {
public static final String rcsid = "$Id: DimHash.java,v 1.6 2000/11/03 08:01:05 ajk Exp $";

    boolean cached;
    DimHash(Writable writable, boolean cache) {
	super(writable);
	if(cache) {
	    cached = true;
	    nolla = new Object();
	    hp = new Hashtable();
	    hm = new Hashtable();
	}
    }


    public void fillHdrRecord(Recs.HdrRecord h) {
	super.fillHdrRecord(h);
	h.id = 4253641; // Just a random thing.
    }

    final int plusbit = 1;

    /** Store a key pair.
     * NOTE that this does not clear the former pairs: 
     * that has to be done manually. So if you have (X,Y)
     * and store (X,Z) then searching for (X,*) yields (X,Z)
     * but searching for (*,Y) still gives (X,Y).
     */
    public void put(String id1, String id2) {
	// if(id1.equals("")) throw new ZZError("NOSTRING FOR PUT");
	// if(id2.equals("")) throw new ZZError("NOSTRING FOR PUT");
	if(id1!=null) hp.put(id1, (id2==null?nolla:id2));
	if(id2!=null) hm.put(id2, (id1==null?nolla:id1));
	if(id1==null) id1 = "";
	if(id2==null) id2 = "";
	Recs.ConnRecord cr1 = new Recs.ConnRecord(),
		        cr2 = new Recs.ConnRecord();
	cr1.hash = (id1.hashCode() & ~plusbit); cr1.cell = id1; 
					cr1.othoffs = (short)cr1.length();
	long offs = putTreeRecord(cr1);
	cr2.hash = (id2.hashCode() | plusbit); cr2.cell = id2; 
					cr2.othoffs = (short)(offs-hdr.end);
	putTreeRecord(cr2);
    }

    /** A "null" object, as distinct from "unknown".
     */
    Object nolla; 
    Hashtable hp;
    Hashtable hm;

    public void clearCache() {
	hp = new Hashtable();
	hm = new Hashtable();
    }

    public String get(String id, int dir) {
// 	clearCache(); // XXX

	Object res = null;
	Hashtable h = null;

	if(cached) {
	    if(dir > 0) h = hp; else h = hm;
	    res = h.get(id);
	}

	if(res!=null) {
	    if(res == nolla) return null;
	    if(res.equals("")) return null; 
		    // throw new ZZError("NOSTRING IN RES");
	    return (String)res;
	}
	int hash = id.hashCode();
	if(dir > 0) hash &= ~plusbit;
	else hash |= plusbit;

	// p("HITDISK! "+id+" "+hash+" "+dir+" "+reads+"\t"+this);


	Recs.ConnRecord r = null; 
	do {
            Recs.Record pr = findRecord(r, hash);
            try {
                r = (Recs.ConnRecord)pr;
            } catch (java.lang.ClassCastException e) {
                throw new ZZInvalidDimensionError("format error: " + e);
            }
	} while(r!=null && (r.hash != hash || !r.cell.equals(id)));
	if(r==null) {
	    h.put(id, nolla);
	    return null;
	}
	long o = 0;
	o = r.getOffset() + r.othoffs;
	Recs.ConnRecord r2 = (Recs.ConnRecord)readRecord(o);
	String ret = r2.cell;
	if(r2.cell.equals("")) {
	    ret = null;
	    if(cached) h.put(id, nolla);
	} else {
	    if(cached) h.put(id, ret);
	}
	return ret;
    }

}
