/*   
TestDimHash.java
 *    
 *    Copyright (c) 2000, Ted Nelson and Tuomas Lukka
 *
 *    You may use and distribute under the terms of either the GNU Lesser
 *    General Public License, either version 2 of the license or,
 *    at your choice, any later version. Alternatively, you may use and
 *    distribute under the terms of the XPL.
 *
 *    See the LICENSE.lgpl and LICENSE.xpl files for the specific terms of 
 *    the licenses.
 *
 *    This software is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the README
 *    file for more details.
 *
 */
/*
 * Written by Tuomas Lukka
 */
package org.gzigzag;
import java.util.*;
import java.io.*;

/** DEPRECATED. Some tests for the DimHash class.
 */

public class TestDimHash {
public static final String rcsid = "$Id: TestDimHash.java,v 1.5 2000/09/19 10:32:01 ajk Exp $";

static final void p(String s) { System.out.println(s); }
static void t(Object o1, Object o2) {
    t((String)o1, (String)o2);
}

static void t(String s1, String s2) {
    if(s1==s2 ||
       (s1 != null && s1.equals(s2))) {
	p("Correct: '"+s1+"'");
    } else {
	p("INCORRECT! Was '"+s1+"' should be '"+s2+"'");
    }
}
public static void main(String[] argv) {
    DirSet s = new DirSet(new File("/tmp"), "rw");
    Writable w = s.getWritable("dimhashtest");
    DimHash d = new DimHash(w, true);
    d.clearStart();
    if(true) {
	t(d.get("x", 1), null);
	t(d.get("x", 1), null);
	t(d.get("x", -1), null);
	d.put("x", "x");
	t(d.get("x", 1), "x");
	t(d.get("x", -1), "x");
	d.put("x", "y");
	t(d.get("x", 1), "y");
	t(d.get("x", -1), "x");
	t(d.get("y", -1), "x");
	d.put("z", "x");
	t(d.get("x", 1), "y");
	t(d.get("x", -1), "z");
	t(d.get("z", 1), "x");
    }

    Writable w2 = s.getWritable("conthashtest");
    ContentHash c = new ContentHash(w2);
    c.clearStart();
    t(c.get("x"), null);
    t(c.get("y"), null);
    t(c.get("z"), null);
    c.put("x", "abc");
    c.put("z", "def");
    t(c.get("x"), "abc");
    t(c.get("y"), null);
    t(c.get("z"), "def");
    c.put("x", "");
    t(c.get("x"), "");
    t(c.get("y"), null);
    t(c.get("z"), "def");
}
}
