/*   
ZZPersistentDimension.java
 *    
 *    Copyright (c) 2000, Ted Nelson and Tuomas Lukka
 *
 *    You may use and distribute under the terms of either the GNU Lesser
 *    General Public License, either version 2 of the license or,
 *    at your choice, any later version. Alternatively, you may use and
 *    distribute under the terms of the XPL.
 *
 *    See the LICENSE.lgpl and LICENSE.xpl files for the specific terms of 
 *    the licenses.
 *
 *    This software is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the README
 *    file for more details.
 *
 */
/*
 * Written by Tuomas Lukka
 */
package org.gzigzag;
import java.util.*;

/** DEPRECATED. Dimension-centric implementation of a persistent dimension 
 * stored in a Writable (currently a file).
 */
public class ZZPersistentDimension extends ZZDimension {
public static final String rcsid = "$Id: ZZPersistentDimension.java,v 1.14 2000/11/05 19:11:13 tjl Exp $";
	public static final boolean dbg = false;
        final static void p(String s) { if(dbg) System.out.println(s); }
        final static void pa(String s) { System.out.println(s); }

	DimHash dh;
	public ZZPersistentDimension(Writable w, boolean useold) {
            try {
                dh = new DimHash(w, true);
                if(useold) dh.start();
                else dh.clearStart();
            } catch (Recs.InvalidMagic e) {
                throw new ZZInvalidDimensionError(""+e);
            } catch (WritableHash.InvalidHeader e) {
                throw new ZZInvalidDimensionError(""+e);
            }
	}

	public ZZCellHandle s(ZZCellHandle c0, int steps, ZZObs o) {
	    String c = c0.id;
	    //p("Gets: "+c+" "+steps);
            try {
		String s = c;
		if(o != null) triggers.addObs(s, o);
		if(steps>0)
		    while(steps-- > 0 && s != null) {
			s = dh.get(s, 1);
			if(o != null) triggers.addObs(s, o);
		    }
		else
		    while(steps++ < 0 && s != null) {
			s = dh.get(s, -1); 
			if(o != null) triggers.addObs(s, o);
		    }

		if(s==null) return null;
		//p("s: "+s);
		return (ZZCellHandle)space.getCellByID(s);
            } catch (Recs.InvalidMagic m) {
                throw new ZZInvalidDimensionError(""+m);
            }
	}
	public void connect(ZZCellHandle c0, ZZCellHandle d0) {
	    String c = c0.id;
	    String d = d0.id;
	    p("Conn: "+dh+" "+c+" "+d);
            try {
		// disconnect(c, 1);
		// disconnect(d, -1);
		if(dh.get(c, 1) != null ||
		   dh.get(d, -1) != null)
		    throw new ZZConnectWouldBreakError("Would break");
		dh.put(c, d);
		triggers.chg(c);
		triggers.chg(d);
            } catch (Recs.InvalidMagic m) {
                throw new ZZInvalidDimensionError(""+m);
            }
	}

	public void disconnect(ZZCellHandle c0, int dir) {
	    String c = c0.id;
            try {
                String o;
                p("Disc: "+dh+" "+c+" "+dir);
                o = dh.get(c, dir);
                if(o!=null) {
                    if(dir>0) {
                        dh.put(c, "");
                        dh.put("", o);
                    } else {
                        dh.put(o,"");
                        dh.put("", c);
                    }
                }
                triggers.chg(c);
            } catch (Recs.InvalidMagic m) {
                throw new ZZInvalidDimensionError(""+m);
            }
	}

}
