/*   
ZZApplet.java
 *    
 *    Copyright (c) 1999, Ted Nelson and Tuomas Lukka
 *
 *    You may use and distribute under the terms of either the GNU Lesser
 *    General Public License, either version 2 of the license or,
 *    at your choice, any later version. Alternatively, you may use and
 *    distribute under the terms of the XPL.
 *
 *    See the LICENSE.lgpl and LICENSE.xpl files for the specific terms of 
 *    the licenses.
 *
 *    This software is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the README
 *    file for more details.
 *
 */
/*
 * Written by Benjamin Fallenstein
 */

package org.gzigzag;

import java.awt.*;
import java.applet.*;
import java.io.*;
import java.util.*;

// XXX Should really store the data somewhere. Currently ^S fails.
class DummyStreamSet extends StreamSet {
    public InputStream getInputStream(String id) { return null; }
    public OutputStream getAppendStream(String id) { return null; }
    public boolean exists(String id) { return false; }
    public Writable getWritable(String id) { return null; }
}

public class ZZApplet extends Applet {
    public static final String rcsid = "$Id: ZZApplet.java,v 1.8 2000/12/11 09:20:48 raulir Exp $";
    
    public void init() {
	ZZWindows.toplevels = false;
	ScalableFont.fmComp = this;
	ZZSpace space = new ZZCacheDimSpace(new DummyStreamSet());
	ZZCell home=space.getHomeCell();

	ZZDefaultSpace.create(home);

	ZZCell topl = ZZWindows.startCell(space).s("d.1", 1)
			.s("d.2", 1);
	ZZCell col;
	if((col=topl.s("d.color", 1)) != null) {
	    setBackground( Color.decode(col.getText()) );
	    if((col=col.s("d.color", 1)) != null) 
		setForeground( Color.decode(col.getText()) );
	}
	Component cont = ZZWindows.getContent(topl.s("d.1", 1));
	setLayout(new BorderLayout());
	add(cont, "Center");
    }
}
